<?php
/**
 * @filename DefaultFactory.php
 * @author Jerry Yan <792602257@qq.com>
 * @date 2020/12/17 14:48
 */


namespace JerryYan\DSL\Token\Factory;


use JerryYan\DSL\Token\Token;
use JerryYan\DSL\Token\TokenLogicAnd;
use JerryYan\DSL\Token\TokenDefine;
use JerryYan\DSL\Token\TokenLogicEqual;
use JerryYan\DSL\Token\TokenLogicOr;
use JerryYan\DSL\Token\TokenVariable;

class DefaultFactory extends FactoryInterface
{
    protected $tokenMap = [
        Token::LOGIC_AND => TokenLogicAnd::class,
        Token::LOGIC_OR => TokenLogicOr::class,
        Token::LOGIC_EQUAL => TokenLogicEqual::class,
        Token::VARIABLE => TokenVariable::class,
        Token::DEFINE => TokenDefine::class,
    ];

    protected $undefinedTokenClass = TokenVariable::class;
}